/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

/* generated by mkview.py */

#ifndef __MyView_h__
#define __MyView_h__

#include "datatool/datatool.h"

namespace fe
{

/// test view specification
class AccessView : public View
{
	public:
		AccessView(sp<Scope> spScope)
		{
			m_a_MyF32.setup(spScope, "MyF32");
			m_accessors.push_back(m_a_MyF32);
			m_a_blat.setup(spScope, "blat");
			m_accessors.push_back(m_a_blat);
		}
		/// test accesor
		/// test accesor
		F32 &MyF32(void)
		{
			if(!m_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_MyF32(m_record);
		}
		/// test accesor
		/// test accesor
		F32 &MyF32(Record &a_record)
		{
			if(!a_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_MyF32(a_record);
		}
		/// another
		int &blat(void)
		{
			if(!m_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_blat(m_record);
		}
		/// another
		int &blat(Record &a_record)
		{
			if(!a_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_blat(a_record);
		}
	private:
		Accessor<F32> m_a_MyF32;
		Accessor<int> m_a_blat;
};

class thingView : public View
{
	public:
		thingView(sp<Scope> spScope)
		{
			m_a_blob.setup(spScope, "blob");
			m_accessors.push_back(m_a_blob);
		}
		int &blob(void)
		{
			if(!m_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_blob(m_record);
		}
		int &blob(Record &a_record)
		{
			if(!a_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_blob(a_record);
		}
	private:
		Accessor<int> m_a_blob;
};

class appdataView : public View
{
	public:
		static const int ms_run = 1;
		static const int ms_pause = 2;
		appdataView(sp<Scope> spScope)
		{
			m_a_runlevel.setup(spScope, "runlevel");
			m_accessors.push_back(m_a_runlevel);
		}
		int &runlevel(void)
		{
			if(!m_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_runlevel(m_record);
		}
		int &runlevel(Record &a_record)
		{
			if(!a_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_runlevel(a_record);
		}
	private:
		Accessor<int> m_a_runlevel;
};

#if FALSE
class particleView : public View
{
	public:
		particleView(sp<Scope> spScope)
		{
			m_a_mass.setup(spScope, "mass");
			m_accessors.push_back(m_a_mass);
			m_a_location.setup(spScope, "location");
			m_accessors.push_back(m_a_location);
		}
		float &mass(void)
		{
			if(!m_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_mass(m_record);
		}
		float &mass(Record &a_record)
		{
			if(!a_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_mass(a_record);
		}
		SpatialVector &location(void)
		{
			if(!m_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_location(m_record);
		}
		SpatialVector &location(Record &a_record)
		{
			if(!a_record.isValid())
			{
				feX("invalid record");
			}
			return m_a_location(a_record);
		}
	private:
		Accessor<float> m_a_mass;
		Accessor<SpatialVector> m_a_location;
};
#endif

} /* namespace */

#endif
