/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __fbx_SurfaceAccessibleFbx_h__
#define __fbx_SurfaceAccessibleFbx_h__

namespace fe
{

/**************************************************************************//**
    @brief FBX Surface Binding

	@ingroup fbx
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleFbx:
	public SurfaceAccessibleJoint
{
	public:
				SurfaceAccessibleFbx(void);
virtual			~SurfaceAccessibleFbx(void);

				//* as SurfaceAccessibleI

				using SurfaceAccessibleJoint::load;

virtual	BWORD	load(String a_filename,sp<Catalog> a_spSettings);

	private:

	class FileContext: public Component
	{
		public:
						FileContext(void);
	virtual				~FileContext(void);

			FbxManager*	m_pFbxManager;
			FbxScene*	m_pFbxScene;
	};

		BWORD			setContext(String a_filename);
		BWORD			loadScene(const char* a_pFilename);
		void			readTransformations(FbxNode* a_pFbxNode);

		String			m_filename;
		Real			m_fps;

		sp<FileContext>	m_spContext;
};

} // namespace

#endif /* __fbx_SurfaceAccessibleFbx_h__ */
