import sys
import os
forge = sys.modules["forge"]

def setup(module):

	srcList = [	"BasisSpline",
				"ConvergentSpline",
				"Geodesic",
				"InvKineCCD",
				"Noise",
				"PointConnect",
				"geometry.pmh",
				"geometryDL"
				]

	dll = module.DLL( "fexGeometryDL", srcList )

	for src in [ "Noise" ]:
		relativePath = forge.RelativePath(forge.rootPath,module.modPath)
		modObjPath = os.path.join(forge.objPath, relativePath)
		objName = modObjPath + '/' + src + forge.objsuf
		srcTarget = forge.FindTarget(objName)

		srcTarget.cppmap = {}
		srcTarget.cppmap['std'] = '-std=c++11'

	deplibs = forge.corelibs+ [
				"feSignalLib",
				"fexMathLib",
				"fexDataToolLib" ]

	forge.deps( ["fexGeometryDLLib"], deplibs )

#	forge.tests += [
#		("inspect.exe",		"fexGeometryDL",				None,		None) ]

	module.Module( 'test' )
