import sys
import os
import re
forge = sys.modules["forge"]

def setup(module):

	version = ""
	for line in open("ext/lua/lua/src/lua.h").readlines():
		if re.match("#define LUA_VERSION_NUM.*", line):
			version = line.split()[2].rstrip()

	if version != "":
		sys.stdout.write(" " + version)

	srcList = [	"lapi.c",
				"lcode.c",
				"ldebug.c",
				"ldo.c",
				"ldump.c",
				"lfunc.c",
				"lgc.c",
				"llex.c",
				"lmem.c",
				"lobject.c",
				"lopcodes.c",
				"lparser.c",
				"lstate.c",
				"lstring.c",
				"ltable.c",
				"ltests.c",
				"ltm.c",
				"lundump.c",
				"lvm.c",
				"lzio.c" ]

	dll = module.Lib( "lua", srcList )

	module.includemap = { 'lua' : os.path.join(module.modPath,'.') }
	#module.includemap = { 'lualib' : os.path.join(module.modPath,'..','include') }

	srcList = [	"lauxlib.c",
				"lbaselib.c",
				"ldblib.c",
				"liolib.c",
				"lmathlib.c",
				"ltablib.c",
				"lstrlib.c",
				"loadlib.c" ]

	deplibs = forge.corelibs + [ "luaLib" ]

	dll = module.Lib( "lualb", srcList )


	#module.Module('lib')

