/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "opencl.pmh"

namespace fe
{

void SurfaceCurvesOpenCL::drawInternal(BWORD a_transformed,
	const SpatialTransform* a_pTransform,sp<DrawI> a_spDrawI,
	const fe::Color* a_pColor,sp<DrawBufferI> a_spDrawBuffer,
	sp<PartitionI> a_spPartition) const
{
//	feLog("SurfaceCurvesOpenCL::drawInternal\n");

	sp<Catalog> spCatalog(a_spDrawBuffer);
	if(spCatalog.isValid())
	{
		sp<SurfaceAccessibleOpenCL> spSurfaceAccessibleOpenCL(
				m_spSurfaceAccessibleI);
		if(spSurfaceAccessibleOpenCL.isValid())
		{
//			feLog("  accessible %p\n",spSurfaceAccessibleOpenCL.raw());

			sp<SurfaceAccessibleOpenCL::Bridge> spPositionBridge=
					spSurfaceAccessibleOpenCL->lookupBridge("pt:P",FALSE);
			if(spPositionBridge.isValid())
			{
				spPositionBridge->safeLock();
				sp<SurfaceAccessibleOpenCL::ClMem> spClMem=
//						spPositionBridge->getClMem();
						spPositionBridge->m_spClMemPrevious;
				spPositionBridge->safeUnlock();

				if(spClMem.isValid())
				{
//~					spCatalog->catalog<I32>("cl:pointCount")=
//~							m_spSurfaceAccessibleI->count(
//~							SurfaceAccessibleI::e_point);
					spCatalog->catalog< sp<Counted> >("cl:pt:P")=spClMem;

					feLog("  set done\n");
				}
			}
		}
	}

	SurfaceCurvesAccessible::drawInternal(a_transformed,a_pTransform,
			a_spDrawI,a_pColor,a_spDrawBuffer,a_spPartition);
}

} // namespace
