import sys
import re
forge = sys.modules["forge"]

def setup(module):

	version = ""
	for line in open(forge.opencl_include + "/CL/cl.h").readlines():
		if re.match("#define CL_VERSION_.*", line):
			version = line.split()[1][11:].rstrip().replace("_",".")

	if version != "":
		sys.stdout.write(" " + version)

	srcList = [ "opencl.pmh",
				"CacheCLOp",
				"ContractCLOp",
				"CurlCLOp",
				"FlatnessCLOp",
				"OpenCLOp",
				"SurfaceAccessibleOpenCL",
				"SurfaceAccessorOpenCL",
				"SurfaceCurvesOpenCL",
				"SurfaceTrianglesOpenCL",
				"TransformCLOp",
				"openclDL" ]

	dll = module.DLL( "fexOpenCLDL", srcList )

	module.includemap = {}
	module.includemap['opencl'] = forge.opencl_include

	module.cppmap = { 'std' : "-std=c++11" }

	dll.linkmap = {}
	dll.linkmap['opencl'] = "-Xlinker -rpath='" + forge.opencl_lib + "'"
	dll.linkmap['opencl'] += ' -L' + forge.opencl_lib + ' -lOpenCL'

	deplibs = forge.corelibs + [
				"feSignalLib",
				"fexMathLib",
				"fexGeometryDLLib",
				"fexOperatorDLLib",
				"fexDataToolDLLib",
				"fexWindowLib"	]

	forge.deps( ["fexOpenCLDLLib"], deplibs )

def auto(module):
	test_file = """
#include <CL/cl.h>

int main(void)
{
	return(0);
}
    \n"""

	# TODO also configurable (as above)
	forge.includemap['opencl'] = forge.opencl_include

	result = forge.cctest(test_file)

	forge.includemap['opencl'] = ''

	return result
