import os
import sys
forge = sys.modules["forge"]

def setup(module):
	if forge.pcre_include == "":
		sys.stdout.write(" -" + str(pcre_version))

	pcre_config = ""
	if forge.pcre_lib == 'auto':
		pcre_config = "pcre-config"
	else:
		pcre_config = forge.pcre_lib + "/pcre-config"
		if not os.path.exists(pcre_config):
			pcre_config = forge.pcre_lib + "/../bin/pcre-config"
			if not os.path.exists(pcre_config):
				pcre_config = ""

	pcre_version = ""
	if pcre_config != "":
		pcre_check = os.popen(pcre_config + " --version",'r')
		pcre_version = pcre_check.read()
		pcre_check.close()

	if pcre_version != "":
		pcre_version = float(pcre_version)
		sys.stdout.write(" " + str(pcre_version))

	srcList = [	"pcre.pmh",
				"pcreDL" ]

	module.includemap = {}

	if forge.pcre_lib != 'auto':
		module.includemap['pcre'] = forge.pcre_include

	dll = module.DLL( "fexPcre", srcList )

	deplibs = [ "fePlatformLib" ]

	dll.linkmap = {}

	if forge.pcre_lib != 'auto':
		dll.linkmap['pcre'] = "-Xlinker -rpath='" + forge.pcre_lib + "'"
		dll.linkmap['pcre'] += ' -L' + forge.pcre_lib

	dll.linkmap["pcrecpp"] = "-lpcrecpp"

	forge.deps( ["fexPcreLib"], deplibs )

def auto(module):
	if forge.pcre_include == '':
		return 'unset'

	test_file = """
#include <pcrecpp.h>

int main(void)
{
	return pcrecpp::RE("a?c").FullMatch("abc");
}
    \n"""

	scenemap = { }
	if forge.fe_os == "FE_LINUX":
		scenemap["scenelibs"] = "-lpcrecpp"

	if forge.pcre_include != 'auto':
		forge.includemap['pcre'] = forge.pcre_include

		forge.linkmap['pcre'] = "-Xlinker -rpath='" + forge.pcre_lib + "'"
		forge.linkmap['pcre'] += ' -L' + forge.pcre_lib + ' -lpcrecpp'

	result = forge.cctest(test_file, scenemap)

	if forge.pcre_include != 'auto':
		forge.includemap['pcre'] = ""

		forge.linkmap['pcre'] = ""

	return result
