import os
import sys
import re
forge = sys.modules["forge"]

def find_ptex_so():
	libFiles = os.listdir(forge.ptex_lib)
	for libFile in libFiles:
		if re.match(".*\.so", libFile):
			return libFile

	return "libptex.so.1.1"

def setup(module):

	srcList = [	"SurfaceAccessiblePtex",
				"ptex.pmh",
				"ptexDL" ]

	dll = module.DLL( "fexPtexDL", srcList )

	deplibs = forge.corelibs+ [
				"fexSurfaceDLLib",
				"fexTerminalDLLib" ]

	forge.deps( ["fexPtexDLLib"], deplibs )

#	module.includemap = { 'ptex' : module.modPath }
	module.includemap = { 'ptex' : forge.ptex_include }

	module.linkmap = {}

	soFile = find_ptex_so()

	module.linkmap['ptex'] = "-Xlinker -rpath='" + forge.ptex_lib + "'"
	module.linkmap['ptex'] += ' -L' + forge.ptex_lib + ' -l:' + soFile

	forge.tests += [
		("inspect.exe",		"fexPtexDL",				None,		None) ]

	for line in open(forge.ptex_include + "/Ptexture.h").readlines():
		if re.match("#define PtexAPIVersion.*", line):
			version = line.split(' ')[2].rstrip()
			sys.stdout.write(" " + version)
			break

#	module.Module('ptex')

def auto(module):
	if forge.ptex_include == '':
		return 'unset'

	if not os.path.exists(forge.ptex_include):
		return 'include path'

	if not os.path.exists(forge.ptex_lib):
		return 'lib path'

	test_file = """
#include "Ptexture.h"

int main(void)
{
	return(0);
}
    \n"""

	forge.includemap['ptex'] = forge.ptex_include

	soFile = find_ptex_so()

	forge.linkmap['ptex'] = "-Xlinker -rpath='" + forge.ptex_lib + "'"
	forge.linkmap['ptex'] += ' -L' + forge.ptex_lib + ' -l:' + soFile

	result = forge.cctest(test_file)

	forge.includemap['ptex'] = ''
	forge.linkmap['ptex'] = ''

	return result
