/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessibleVDB_h__
#define __surface_SurfaceAccessibleVDB_h__

namespace fe
{

/**************************************************************************//**
    @brief VDB Surface Binding

	@ingroup vdb
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleVDB:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleVDB(void)					{}
virtual							~SurfaceAccessibleVDB(void)					{}

								//* as SurfaceAccessibleI
virtual	void					reset(void)									{}

virtual	BWORD					isBound(void)
								{	return bool(m_gridPtr); }

								using SurfaceAccessibleBase::load;

virtual	BWORD					load(String a_filename,
										sp<Catalog> a_spSettings);

								using SurfaceAccessibleBase::surface;

virtual	sp<SurfaceI>			surface(String a_group);

	private:
		openvdb::GridBase::ConstPtr		m_gridPtr;
};

} // namespace

#endif /* __surface_SurfaceAccessibleVDB_h__ */
