print ">> Import skin"
importOp = createOperator("ImportOp")
importOp["loadfile"] = "skin.rg"
skin = importOp()

print ">> Subdivide skin"
subdivideOp = createOperator("SubdivideOp")
subdivideOp["depth"] = 1
subdivided = subdivideOp(skin)

print ">> Scatter cores"
scatterOp_cores = createOperator("ScatterOp")
scatterOp_cores["template"] = "density.xpm"
scatterOp_cores["density"] = 200
cores = scatterOp_cores(skin)

print ">> Scatter follicles"
scatterOp_follicles = createOperator("ScatterOp")
scatterOp_follicles["template"] = "density.xpm"
scatterOp_follicles["density"] = 40000
follicles = scatterOp_follicles(subdivided)

print ">> Map length"
mapOp_length= createOperator("MapOp")
mapOp_length["template"]="length.<UDIM>.tx"
mapOp_length["attribute"]="length"
mapOp_length["toMin"]=0.2
mapOp_length["toMax"]=0.4
cores = mapOp_length(cores)
follicles = mapOp_length(follicles)

print ">> Create curve"
curveCreateOp = createOperator("CurveCreateOp")
curveCreateOp["segments"] = 20
strand = curveCreateOp()

print ">> Set radius"
surfaceAttrCreateOp= createOperator("SurfaceAttrCreateOp")
surfaceAttrCreateOp["name"] = "radius"
surfaceAttrCreateOp["class"] = "point"
surfaceAttrCreateOp["type"] = "real"
surfaceAttrCreateOp["writeValues"] = true
surfaceAttrCreateOp["value"] = "1e-4"
surfaceAttrCreateOp["rampValue"] = true
surfaceAttrCreateOp["rampTo"] = "1e-6"
surfaceAttrCreateOp["rampGamma"] = "4.0"
strand = surfaceAttrCreateOp(strand)

print ">> Copy strand"
surfaceCopyOp= createOperator("SurfaceCopyOp")
surfaceCopyOp["scaleAttr"] = "length"
surfaceCopyOp["copyAttr"] = "uv"
strands = surfaceCopyOp(strand, follicles)
guides = surfaceCopyOp(strand, cores)

--print ">> Create direction"
--surfaceAttrCreateOp= createOperator("SurfaceAttrCreateOp")
--surfaceAttrCreateOp["name"] = "direction"
--surfaceAttrCreateOp["class"] = "primitive"
--surfaceAttrCreateOp["type"] = "vector"
--surfaceAttrCreateOp["writeValues"] = true
--surfaceAttrCreateOp["value"] = "0 -1 0"
--strands = surfaceAttrCreateOp(strands)
--guides = surfaceAttrCreateOp(guides)

print ">> Map direction"
mapOp_direction= createOperator("MapOp")
mapOp_direction["template"]="direction.<UDIM>.tx"
mapOp_direction["attribute"]="direction"
mapOp_direction["class"] = "primitive"
mapOp_direction["type"] = "vector"
mapOp_direction["toMin"]=-1
mapOp_direction["toMax"]=1
guides = mapOp_direction(guides)
mapOp_direction["random"]=0.1
strands = mapOp_direction(strands)

print ">> Flatness"
flatnessOp = createOperator("FlatnessOp")
flatnessOp["facingAttr"] = "direction"
flatnessOp["rotateRoot"] = 0.5
flatnessOp["rotateTip"] = 1.0
guides_flattened = flatnessOp(guides)
flatnessOp["random"] = 0.1
strands_flattened = flatnessOp(strands)

--print ">> Curl"
--curlOp = createOperator("CurlOp")
--curlOp["amplitude"] = 0.015
--curlOp["spin"] = 1080.0
--curled = curlOp(strands)

print ">> Kink"
kinkOp = createOperator("KinkOp")
kinkOp["amplitudeTip"] = 0.1
kinkOp["amplitudeRandom"] = 0.05
kinkOp["frequencyRoot"] = 4.0
kinkOp["frequencyTip"] = 4.0
kinkOp["facingAttr"] = "direction"
kinked = kinkOp(strands_flattened)

print ">> Clump"
clumpOp = createOperator("ClumpOp")
clumpOp["convergenceTip"] = 0.9
clumped = clumpOp(kinked, guides_flattened)

print ">> Contract"
contractOp = createOperator("ContractOp")
contractOp["contraction"] = 0.5
contracted = contractOp(clumped)

--print ">> Export"
--exportOp = createOperator("ExportOp")
--exportOp["savefile"] = "fur.rg"
--exportOp(contracted)

print ">> Replace"
--replaceOutputWith(contracted)
output=contracted
