print("\nFRAME " .. frame)

if count == nil then
	print "nil"
	count = 0
end
print("count " .. count)
count = count + 1

if count == 1 then
	print ">> Import skin"
	importOp = createOperator("ImportOp")
	importOp["loadfile"] = "skin.rg"
	skin = importOp()

	print ">> Subdivide skin"
	subdivideOp = createOperator("SubdivideOp")
	subdivideOp["depth"] = 1
	subdivided = subdivideOp(skin)

	print ">> Scatter follicles"
	scatterOp = createOperator("ScatterOp")
	scatterOp["density"] = 2000
	follicles = scatterOp(subdivided)

	print ">> Create curve"
	curveCreateOp = createOperator("CurveCreateOp")
	curveCreateOp["segments"] = 80
	strand = curveCreateOp()

	print ">> Copy strand"
	surfaceCopyOp= createOperator("SurfaceCopyOp")
	strands = surfaceCopyOp(strand, follicles)

	use_OpenCL = true

	if use_OpenCL then
		cacheOp = createOperator("CacheCLOp")
		flatnessOp = createOperator("FlatnessCLOp")
		curlOp = createOperator("CurlCLOp")
		contractOp = createOperator("ContractCLOp")
	else
		-- TODO need the copy-back to CPU memory
		cacheOp = createOperator("NullOp")
		flatnessOp = createOperator("FlatnessOp")
		curlOp = createOperator("CurlOp")
		contractOp = createOperator("ContractOp")
	end

--	transformOp = createOperator("TransformCLOp")
end

print ">> Cache (clone)"
curves = cacheOp(strands)

print ">> Flatness"
flatnessOp["rotateRoot"] = 0.4
flatnessOp["rotateTip"] = 0.8
flattened=flatnessOp(curves)

print ">> Curl"
curlOp["amplitude"] = 0.05*math.sin(0.2*count)
curlOp["spin"] = 4.0
curled=curlOp(flattened)

print ">> Contract"
contractOp["contraction"] = 0.5
contracted=contractOp(curled)

--print ">> Transform"
--angle = 0.01*count
--transformOp["rotateX"] = Vector3( math.cos(angle), 0, -math.sin(angle) )
--transformOp["rotateZ"] = Vector3( math.sin(angle), 0, math.cos(angle) )
--spun=transformOp(curled)

output=contracted
