/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __platform_thread_h__
#define __platform_thread_h__

namespace fe
{

/*
	boost::thread_group*	m_pGroup;
	boost::thread**			m_ppThread;

	a_threads=boost::thread::hardware_concurrency();

	m_pGroup=new boost::thread_group();
	m_ppWorker=new WORKER*[a_threads];
	m_ppThread=new boost::thread*[a_threads];

	m_ppThread[m]=m_pGroup->create_thread(
			*m_ppWorker[m]);
	m_ppThread[n]->interrupt();
	m_pGroup->join_all();
	m_pGroup->remove_thread(m_ppThread[m]);

	boost::this_thread::interruption_point();

	boost::thread_specific_ptr< Array< sp<T> > >*	m_pTssArray;

	Array< sp<T> >* pArray;
	if(!(pArray=m_pTssArray->get()))
	{
		pArray=new Array< sp<T> >();
		m_pTssArray->reset(pArray);
*/

extern "C"
{

typedef void* (ThreadDefaultInitFunction)(void);
typedef void* (ThreadInitFunction)(void* a_pFunctor);
typedef void (ThreadInterruptFunction)(void* a_pRawThread);
typedef void (ThreadJoinFunction)(void* a_pRawThread);
typedef void (ThreadFinishFunction)(void* a_pRawThread);
typedef void (ThreadInterruptionFunction)(void);
typedef int (ThreadConcurrencyFunction)(void);

typedef void* (ThreadGroupInitFunction)(void);
typedef void* (ThreadGroupCreateFunction)(
		void* a_pRawThreadGroup,void* a_pFunctor);
typedef void (ThreadGroupJoinAllFunction)(void* a_pRawThreadGroup);
typedef void (ThreadGroupFinishFunction)(void* a_pRawThreadGroup);

} /* extern "C" */

class FE_DL_PUBLIC FE_DL_EXPORT Thread
{
	public:

	class FE_DL_PUBLIC FE_DL_EXPORT Functor
	{
		public:
					Functor(void);
	virtual			~Functor(void);
	virtual	void	operate(void);

			void	operator()(void);

		protected:
			Functor*	m_pOriginal;	//* operator() 'this' may be different
	};

	class FE_DL_PUBLIC FE_DL_EXPORT Group
	{
		public:
					Group(void);
					~Group(void);

			Thread*	createThread(Functor* a_pFunctor);
			BWORD	joinAll(void);

		private:

			void*	m_pRawThreadGroup;
	};

				Thread(void);
				Thread(Functor* a_pFunctor);
				Thread(void* a_pRawThread);
				~Thread(void);

		BWORD	interrupt(void);
		BWORD	join(void);

static	BWORD	interruptionPoint(void);
static	I32		hardwareConcurrency(void);
static	String	support(void)	{ return ms_support; }

static	void	replaceDefaultInitFunction(
					ThreadDefaultInitFunction* a_fnDefaultInit)
				{	ms_fnDefaultInit=a_fnDefaultInit; }
static	void	replaceInitFunction(
					ThreadInitFunction* a_fnInit)
				{	ms_fnInit=a_fnInit; }
static	void	replaceInterruptFunction(
					ThreadInterruptFunction* a_fnInterrupt)
				{	ms_fnInterrupt=a_fnInterrupt; }
static	void	replaceJoinFunction(
					ThreadJoinFunction* a_fnJoin)
				{	ms_fnJoin=a_fnJoin; }
static	void	replaceFinishFunction(
					ThreadFinishFunction* a_fnFinish)
				{	ms_fnFinish=a_fnFinish; }
static	void	replaceInterruptionFunction(
					ThreadInterruptionFunction* a_fnInterruption)
				{	ms_fnInterruption=a_fnInterruption; }
static	void	replaceConcurrencyFunction(
					ThreadConcurrencyFunction* a_fnConcurrency)
				{	ms_fnConcurrency=a_fnConcurrency; }

static	void	replaceGroupInitFunction(
					ThreadGroupInitFunction* a_fnGroupInit)
				{	ms_fnGroupInit=a_fnGroupInit; }
static	void	replaceGroupCreateFunction(
					ThreadGroupCreateFunction* a_fnGroupCreate)
				{	ms_fnGroupCreate=a_fnGroupCreate; }
static	void	replaceGroupJoinAllFunction(
					ThreadGroupJoinAllFunction* a_fnGroupJoinAll)
				{	ms_fnGroupJoinAll=a_fnGroupJoinAll; }
static	void	replaceGroupFinishFunction(
					ThreadGroupFinishFunction* a_fnGroupFinish)
				{	ms_fnGroupFinish=a_fnGroupFinish; }

	private:

static	BWORD	confirm(void);

static	ThreadDefaultInitFunction*		ms_fnDefaultInit;
static	ThreadInitFunction*				ms_fnInit;
static	ThreadInterruptFunction*		ms_fnInterrupt;
static	ThreadJoinFunction*				ms_fnJoin;
static	ThreadFinishFunction*			ms_fnFinish;
static	ThreadInterruptionFunction*		ms_fnInterruption;
static	ThreadConcurrencyFunction*		ms_fnConcurrency;

static	ThreadGroupInitFunction*		ms_fnGroupInit;
static	ThreadGroupCreateFunction*		ms_fnGroupCreate;
static	ThreadGroupJoinAllFunction*		ms_fnGroupJoinAll;
static	ThreadGroupFinishFunction*		ms_fnGroupFinish;

static	String							ms_support;
static	BWORD							ms_checked;

		void*	m_pRawThread;
};

} /* namespace */

#endif /* __platform_thread_h__ */
